<script lang="ts">
  import Button from '$lib/components/Button.svelte';
  import TextField from '$lib/components/fields/TextField.svelte';
  import SelectField from '$lib/components/fields/SelectField.svelte';
  import EmailField from '$lib/components/fields/EmailField.svelte';
  import { axiosInstance } from '$lib/config/index.js';

  export let contact: any = null;

  let id: number,
    name: string,
    phone: string,
    email: string,
    ssa: any;

  if (contact) {
    id = contact.id;
    name = contact.name;
    phone = contact.phone;
    email = contact.email;
    ssa = contact.SNO ?? [];
  }

  async function handleSubmit() {
    if (name && phone && email && ssa) {
      try {
        const res = await axiosInstance[id ? 'patch' : 'post'](`/contact${id ? `/${id}` : ''}`, {
          name,
          phone,
          email,
          SNO: {}
        });

        if (res.status === 201) {
          window.location.href = '/admin/contacts';
        }

        if (res.status === 200) {
          alert('Успешно сохранено.');
        }
      } catch (err: any) {
        console.error(err);
        switch (err.response.status) {
          case 400:
            alert('Неверные данные');
            break;
          default:
            alert('Возникла ошибка. Попробуйте повторить действие.');
        }
      }
    }
  }
</script>

<form
    method="post"
    on:submit|preventDefault={handleSubmit}
    class="{$$props.class} space-y-6 mx-auto max-w-screen-xl"
>
    <h1 class="text-6xl text-center mb-2 font-serif">
        {#if contact}
            Изменение записи
            <p class="text-lg text-neutral-600"><span class="select-none">ID:</span>{id}</p>
        {:else}
            Создание записи
        {/if}
    </h1>

    <TextField label="ФИО" name="name" bind:value={name}/>
    <TextField label="Телефон" name="phone" bind:value={phone}/>
    <EmailField label="Email" name="email" bind:value={email}/>
<!--    <SelectField label="СНО" name="ssa" bind:value={ssa}/>-->

    <section class="flex justify-center gap-6">
        <a href="/admin/contacts">
            <Button transparent>Отменить</Button>
        </a>
        <Button>
            {#if contact}
                Изменить
            {:else}
                Создать
            {/if}
        </Button>
    </section>
</form>